//A replacement handler
class DRHandler expands DHandler
	config(DCoopReplacements);

struct AReplWith
{
var() config string ReplWith;
var() config float ReplChance;
var class<Actor> ReplaceWith;
};

struct AReplacement
{
var() config string ReplWhat;
var class<Actor> ReplaceWhat;
var() config AReplWith ReplWith[32];
};

var() config AReplacement Repl[512];

function string ToCl(string S)
{
if (S=="") return "";
if (InStr(S,".")>-1) return S;
return "UnrealI."$S;
}

function ReMap()
{
	local int I,J;
	for (I=0;I<512;I++)
	if (Repl[I].ReplWhat!="")
	{
	if (Repl[I].ReplaceWhat==None)
	Repl[I].ReplaceWhat=class<Actor>(DynamicLoadObject(ToCl(Repl[I].ReplWhat),class'Class'));
	for (J=0;J<32;J++)
		if (Repl[I].ReplWith[J].ReplWith!="")
		if (Repl[I].ReplWith[J].ReplChance>0)
		if (Repl[I].ReplWith[J].ReplaceWith==None)
		Repl[I].ReplWith[J].ReplaceWith=class<Actor>(DynamicLoadObject(ToCl(Repl[I].ReplWith[J].ReplWith),class'Class'));
	}
}

function bool Suitable(class<Actor> AClass, int N)
{
	local int I, M;
	local class<Actor> RC;
	if (Repl[N].ReplaceWhat==None) return false;
	M=0;
	if (ClassIsChildOf(AClass,class'Decoration')) M=1;
	if (ClassIsChildOf(AClass,class'Inventory')) M=2;
	if (ClassIsChildOf(AClass,class'Pawn')) M=3;
	if (M==0) { return false; }
	switch (M)
	{
	case 1: RC=class'Decoration'; break;
	case 2: RC=class'Inventory'; break;
	case 3: RC=class'Pawn'; break;
	default: return false;
	}
	if (AClass!=Repl[N].ReplaceWhat) { return false; }
	for (I=0;I<32;I++)
	if (Repl[N].ReplWith[I].ReplaceWith!=None)
		if (ClassIsChildOf(Repl[N].ReplWith[I].ReplaceWith,RC))
			return true;
	return false;
}

function bool Assess(int M, int N, out int Id)
{
	local int I, B, BM;
	local class<Actor> RC;
	local int Mark[32];
	switch (M)
	{
	case 1: RC=class'Decoration'; break;
	case 2: RC=class'Inventory'; break;
	case 3: RC=class'Pawn'; break;
	default: Id=-1; return false;
	}
	for (i=0;i<32;i++)
		{
		Mark[i]=Rand(5000); //Randomize.	
		if ((Repl[N].ReplWith[I].ReplaceWith==None)||(!ClassIsChildOf(Repl[N].ReplWith[I].ReplaceWith,RC)))
			Mark[i]-=10000; //Bleh, this class is not allowed.
		Mark[i]=int(float(Mark[i])*Repl[N].ReplWith[I].ReplChance); //Relate.
		}
	B=-1; BM=-10000;
	for (I=0;I<32;I++)
		if (Mark[I]>BM)
			{BM=Mark[I]; B=I;}
	Id=B; return (B!=-1);
}

/* This is the main function. */
singular function bool ReplaceActor(actor Other)
{
	local int I, N, A, M;
	local class<Actor> AClass;
	AClass=Other.Class;
	if (!ClassIsChildOf(AClass,class'Decoration'))
	if (!ClassIsChildOf(AClass,class'Inventory'))
	if (!ClassIsChildOf(AClass,class'Pawn'))
	return false;
	ReMap();
	N=-1;
	for (I=0;I<512;I++)
	if (Suitable(AClass,I))
	{ N=I; break; }
	if (N==-1) return false;
	M=0;
	if (ClassIsChildOf(AClass,class'Decoration')) M=1;
	if (ClassIsChildOf(AClass,class'Inventory')) M=2;
	if (ClassIsChildOf(AClass,class'Pawn')) M=3;
	if (M==0) return false;
	if (!Assess(M,N,A)) return false;
	if (Other.IsA('Decoration')) return ReplaceDec(Decoration(Other),N,A);
	if (Other.IsA('Inventory')) return ReplaceInv(Inventory(Other),N,a);
	if (Other.IsA('Pawn')) return ReplacePawn(Pawn(Other),N,A);
	return false;
}

function bool ReplaceDec(Decoration Other, int I, int J)
{
	local decoration Dec;
	local bool bCWP, bCW, bCA, bBA, bBP;
	bCWP=Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing;
	//bCW=Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld;
	//bCA=Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors;
	//bBA=Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors;
	//bBP=Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers;
	Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers=False;
	Other.SetCollision(false,false,false);
	Other.bCollideWorld=false;
	Dec=Spawn(class<Decoration>(Repl[I].ReplWith[J].ReplaceWith),Other.Owner,Other.Tag,Other.Location,Other.Rotation);
	Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing=bCWP;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld=bCW;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors=bCA;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors=bBA;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers=bBP;
	if (Dec==None) return true;

	/* Shared actor flags */
	Dec.Event=Other.Event;
	Dec.bIsSecretGoal=Other.bIsSecretGoal;
	Dec.bIsKillGoal=Other.bIsKillGoal;
	Dec.bIsItemGoal=Other.bIsItemGoal;
	Dec.bMovable=Other.bMovable;
	Dec.Group=Other.Group;
	Dec.AttachTag=Other.AttachTag;

	/* Decoration-specific flags */
	Dec.EffectWhenDestroyed=Other.EffectWhenDestroyed;
	Dec.bPushable=Other.bPushable;
	Dec.bOnlyTriggerable=Other.bOnlyTriggerable;
	Dec.contents=Other.contents;
	Dec.content2=Other.content2;
	Dec.content3=Other.content3;
	Copy(Other,Dec);
	return true;
}

function bool ReplaceInv(Inventory Other, int I, int J)
{
	local inventory Inv;
	local bool bCWP, bCW, bCA, bBA, bBP;
	bCWP=Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing;
	//bCW=Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld;
	//bCA=Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors;
	//bBA=Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors;
	//bBP=Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers;
	Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers=False;
	Other.SetCollision(false,false,false);
	Other.bCollideWorld=false;
	Inv=Spawn(class<Inventory>(Repl[I].ReplWith[J].ReplaceWith),Other.Owner,Other.Tag,Other.Location,Other.Rotation);
	Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing=bCWP;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld=bCW;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors=bCA;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors=bBA;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers=bBP;
	if (Inv==None) return true;
	
	/* Shared actor flags */
	Inv.Event=Other.Event;
	Inv.bIsSecretGoal=Other.bIsSecretGoal;
	Inv.bIsKillGoal=Other.bIsKillGoal;
	Inv.bIsItemGoal=Other.bIsItemGoal;
	Inv.bMovable=Other.bMovable;
	Inv.Group=Other.Group;
	Inv.AttachTag=Other.AttachTag;
	
	/* Inventory-specific flags */
	Inv.bInstantRespawn=Other.bInstantRespawn;
	Inv.RespawnTime=Other.RespawnTime;
	
	if (Other.Owner!=None)
	if (Other.bHeldItem)
	if (Other.Owner.IsA('Pawn'))
	Inv.GiveTo(Pawn(Other.Owner));
	Copy(Other,Inv);
	return true;
}

function bool ReplacePawn(Pawn Other, int I, int J)
{
	local pawn Pwn;
	local bool bCWP, bCW, bCA, bBA, bBP;
	bCWP=Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing;
	//bCW=Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld;
	//bCA=Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors;
	//bBA=Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors;
	//bBP=Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers;
	Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors=False;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers=False;
	Other.SetCollision(false,false,false);
	Other.bCollideWorld=false;
	Pwn=Spawn(class<Pawn>(Repl[I].ReplWith[J].ReplaceWith),Other.Owner,Other.Tag,Other.Location,Other.Rotation);
	Repl[I].ReplWith[J].ReplaceWith.default.bCollideWhenPlacing=bCWP;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideWorld=bCW;
	//Repl[I].ReplWith[J].ReplaceWith.default.bCollideActors=bCA;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockActors=bBA;
	//Repl[I].ReplWith[J].ReplaceWith.default.bBlockPlayers=bBP;
	if (Pwn==None) return true;
	
	/* Shared actor flags */
	Pwn.Event=Other.Event;
	Pwn.bIsSecretGoal=Other.bIsSecretGoal;
	Pwn.bIsKillGoal=Other.bIsKillGoal;
	Pwn.bIsItemGoal=Other.bIsItemGoal;
	Pwn.bMovable=Other.bMovable;
	Pwn.Group=Other.Group;
	Pwn.AttachTag=Other.AttachTag;
	
	/* Pawn-specific flags */
	Pwn.DropWhenKilled=Other.DropWhenKilled;
	Pwn.AttitudeToPlayer=Other.AttitudeToPlayer;
	Pwn.AlarmTag=Other.AlarmTag;
	Pwn.SharedAlarmTag=Other.SharedAlarmTag;
	if (Other.IsA('ScriptedPawn')) if (Pwn.IsA('ScriptedPawn'))
	{
		/* ScriptedPawn-specific flags */
		ScriptedPawn(Pwn).TeamTag=ScriptedPawn(Other).TeamTag;
		ScriptedPawn(Pwn).Orders=ScriptedPawn(Other).Orders;
		ScriptedPawn(Pwn).OrderTag=ScriptedPawn(Other).OrderTag;
		ScriptedPawn(Pwn).TimeBetweenAttacks=ScriptedPawn(Other).TimeBetweenAttacks;
		ScriptedPawn(Pwn).Aggressiveness=ScriptedPawn(Other).Aggressiveness;
		ScriptedPawn(Pwn).ReFireRate=ScriptedPawn(Other).ReFireRate;
		ScriptedPawn(Pwn).FirstHatePlayerEvent=ScriptedPawn(Other).FirstHatePlayerEvent;
		ScriptedPawn(Pwn).bNoWait=ScriptedPawn(Other).bNoWait;
	}
	
	Copy(Other,Pwn);
	return true;
}

function Copy( actor Src, actor Dest )
{
	// copy the most class specific components (this list is NOT complete)

	// Advanced
	Dest.bStasis	=	Src.bStasis;

	if (Pawn(Src) != None) 
	{
		// Pawn
		Pawn(Dest).DropWhenKilled	=	Pawn(Src).DropWhenKilled;
		Pawn(Dest).Health			=	Pawn(Src).Health;

		if (ScriptedPawn(Src) != None) {
			// AI
			ScriptedPawn(Dest).AttitudeToPlayer	=	ScriptedPawn(Src).AttitudeToPlayer;
			ScriptedPawn(Dest).bHateWhenTriggered	=	ScriptedPawn(Src).bHateWhenTriggered;
			ScriptedPawn(Dest).bIgnoreFriends		=	ScriptedPawn(Src).bIgnoreFriends;

			// Orders
			ScriptedPawn(Dest).AlarmTag		=	ScriptedPawn(Src).AlarmTag;
			ScriptedPawn(Dest).bDelayedPatrol	=	ScriptedPawn(Src).bDelayedPatrol;
			ScriptedPawn(Dest).bFixedStart		=	ScriptedPawn(Src).bFixedStart;
			ScriptedPawn(Dest).bNoWait			=	ScriptedPawn(Src).bNoWait;
			ScriptedPawn(Dest).Orders			=	ScriptedPawn(Src).Orders;
			ScriptedPawn(Dest).OrderTag		=	ScriptedPawn(Src).OrderTag;
			ScriptedPawn(Dest).SharedAlarmTag	=	ScriptedPawn(Src).SharedAlarmTag;

			if (Brute(Src) != None) {
				// Brute
				Brute(Dest).bTurret	=	Brute(Src).bTurret;
				Brute(Dest).WhipDamage	=	Brute(Src).WhipDamage;
			}

			if (Krall(Src) != None) {
				// Krall
				Krall(Dest).bDicePlayer	=	Krall(Src).bDicePlayer;
				Krall(Dest).bSleeping		=	Krall(Src).bSleeping;
				Krall(Dest).bSpearToss		=	Krall(Src).bSpearToss;
				Krall(Dest).MinDuckTime	=	Krall(Src).MinDuckTime;
				Krall(Dest).PoundDamage	=	Krall(Src).PoundDamage;
				Krall(Dest).StrikeDamage	=	Krall(Src).StrikeDamage;
				Krall(Dest).ThrowDamage	=	Krall(Src).ThrowDamage;
			}

			if (Mercenary(Src) != None) {
				// Mercenary
				Mercenary(Dest).bButtonPusher				=	Mercenary(Src).bButtonPusher;
				Mercenary(Dest).bCanFireWhileInvulnerable	=	Mercenary(Src).bCanFireWhileInvulnerable;
				Mercenary(Dest).bHasInvulnerableShield		=	Mercenary(Src).bHasInvulnerableShield;
				Mercenary(Dest).bSquatter					=	Mercenary(Src).bSquatter;
				Mercenary(Dest).bTalker					=	Mercenary(Src).bTalker;
				Mercenary(Dest).invulnerableCharge			=	Mercenary(Src).invulnerableCharge;
				Mercenary(Dest).OrdersGiven				=	Mercenary(Src).OrdersGiven;
				Mercenary(Dest).PunchDamage				=	Mercenary(Src).PunchDamage;
			}

			if (SkaarjTrooper(Src) != None) {
				// SkaarjTrooper
				SkaarjTrooper(Dest).WeaponType	=	SkaarjTrooper(Src).WeaponType;
			}

			if (WarLord(Src) != None) {
				// WarLord
				WarLord(Dest).bTeleportWhenHurt	=	WarLord(Src).bTeleportWhenHurt;
				WarLord(Dest).StrikeDamage			=	WarLord(Src).StrikeDamage;
			}
		}
	}

	// Collision
	Dest.SetCollision( Src.bCollideActors, Src.bBlockActors, Src.bBlockPlayers );
	Dest.bCollideWorld		=	Src.bCollideWorld;
	Dest.bProjTarget		=	Src.bProjTarget;
	Dest.SetCollisionSize( Src.CollisionRadius, Src.CollisionHeight );

	// Display
	Dest.bUnlit			=	Src.bUnlit;
	Dest.DrawScale		=	Src.DrawScale;
	Dest.Fatness		=	Src.Fatness;
	Dest.MultiSkins[0]	=	Src.MultiSkins[0];
	Dest.MultiSkins[1]	=	Src.MultiSkins[1];
	Dest.MultiSkins[2]	=	Src.MultiSkins[2];
	Dest.MultiSkins[3]	=	Src.MultiSkins[3];
	Dest.MultiSkins[4]	=	Src.MultiSkins[4];
	Dest.MultiSkins[5]	=	Src.MultiSkins[5];
	Dest.MultiSkins[6]	=	Src.MultiSkins[6];
	Dest.MultiSkins[7]	=	Src.MultiSkins[7];
	Dest.ScaleGlow		=	Src.ScaleGlow;
	Dest.Skin			=	Src.Skin;
	Dest.Style			=	Src.Style;
	Dest.Texture		=	Src.Texture;

	// Events
	Dest.Event	=	Src.Event;
	Dest.Tag	=	Src.Tag;

	// Movement
	Dest.bBounce			=	Src.bBounce;
	Dest.bFixedRotationDir	=	Src.bFixedRotationDir;
	Dest.Buoyancy			=	Src.Buoyancy;
	Dest.Mass				=	Src.Mass;
	Dest.SetPhysics( Src.Physics );
	Dest.SetRotation( Src.Rotation );
	Dest.RotationRate		=	Src.RotationRate;

	// Sound
	Dest.AmbientSound			=	Src.AmbientSound;
	Dest.SoundPitch				=	Src.SoundPitch;
	Dest.SoundRadius			=	Src.SoundRadius;
	Dest.SoundVolume			=	Src.SoundVolume;
	Dest.TransientSoundRadius	=	Src.TransientSoundRadius;
	Dest.TransientSoundVolume	=	Src.TransientSoundVolume;
}

defaultproperties
{
}
